import { ProtoRecord } from './proto_record';
/**
 * Removes "duplicate" records. It assuming that record evaluation does not
 * have side-effects.
 *
 * Records that are not last in bindings are removed and all the indices
 * of the records that depend on them are updated.
 *
 * Records that are last in bindings CANNOT be removed, and instead are
 * replaced with very cheap SELF records.
 */
export declare function coalesce(records: List<ProtoRecord>): List<ProtoRecord>;
export declare var __esModule: boolean;
