import { BaseException } from "angular2/src/facade/lang";
export declare const TOKEN_TYPE_CHARACTER: number;
export declare const TOKEN_TYPE_IDENTIFIER: number;
export declare const TOKEN_TYPE_KEYWORD: number;
export declare const TOKEN_TYPE_STRING: number;
export declare const TOKEN_TYPE_OPERATOR: number;
export declare const TOKEN_TYPE_NUMBER: number;
export declare class Lexer {
    tokenize(text: string): List<any>;
}
export declare class Token {
    index: int;
    type: int;
    numValue: number;
    strValue: string;
    constructor(index: int, type: int, numValue: number, strValue: string);
    isCharacter(code: int): boolean;
    isNumber(): boolean;
    isString(): boolean;
    isOperator(operater: string): boolean;
    isIdentifier(): boolean;
    isKeyword(): boolean;
    isKeywordVar(): boolean;
    isKeywordNull(): boolean;
    isKeywordUndefined(): boolean;
    isKeywordTrue(): boolean;
    isKeywordFalse(): boolean;
    toNumber(): number;
    toString(): string;
}
export declare var EOF: Token;
export declare const $EOF: number;
export declare const $TAB: number;
export declare const $LF: number;
export declare const $VTAB: number;
export declare const $FF: number;
export declare const $CR: number;
export declare const $SPACE: number;
export declare const $BANG: number;
export declare const $DQ: number;
export declare const $HASH: number;
export declare const $$: number;
export declare const $PERCENT: number;
export declare const $AMPERSAND: number;
export declare const $SQ: number;
export declare const $LPAREN: number;
export declare const $RPAREN: number;
export declare const $STAR: number;
export declare const $PLUS: number;
export declare const $COMMA: number;
export declare const $MINUS: number;
export declare const $PERIOD: number;
export declare const $SLASH: number;
export declare const $COLON: number;
export declare const $SEMICOLON: number;
export declare const $LT: number;
export declare const $EQ: number;
export declare const $GT: number;
export declare const $QUESTION: number;
export declare const $LBRACKET: number;
export declare const $BACKSLASH: number;
export declare const $RBRACKET: number;
export declare const $LBRACE: number;
export declare const $BAR: number;
export declare const $RBRACE: number;
export declare class ScannerError extends BaseException {
    message: string;
    constructor(message: any);
    toString(): string;
}
export declare var __esModule: boolean;
